/*****************************************************************************/
/*                      WiNRADiO G35DDC EXCALIBUR ULTRA                      */
/*                                SDK DEMO                                   */
/*                        (C) Copyright RADIXON 2014                         */
/*****************************************************************************/

#include "u_mainwindow.h"
#include "u_receiverselector.h"
#include "u_defs.h"
#include "u_global.h"


class TApp: public wxApp
{
public:
    bool OnInit(void);
};

G3XDDCAPI_CREATE_INSTANCE CreateInstance;

bool TApp::OnInit(void)
{
 TMainWindow *MainWindow;
 TReceiver *Receiver;
 HMODULE hAPI; 
 
    hAPI=LoadLibrary(wxT("G35DDCAPI.dll"));

    if(hAPI==NULL)
    {
        wxMessageBox(wxT("Failed to load G35DDCAPI.dll!"),APP_TITLE,wxICON_ERROR);
        return false;
    }

    CreateInstance=(G3XDDCAPI_CREATE_INSTANCE)GetProcAddress(hAPI,"CreateInstance");

    if(CreateInstance==NULL)
    {
        wxMessageBox(wxT("Failed to load valid G35DDCAPI.dll!"),APP_TITLE,wxICON_ERROR);
        FreeLibrary(hAPI);
        return false;
    }

    Global.Initialize();

    Receiver=TReceiverSelector::SelectReceiver();

    if(Receiver==NULL)
    {
        return false;
    }    

    MainWindow=new TMainWindow(Receiver);

    Global.m_MainWindow=MainWindow;

    MainWindow->Show(true);

    return true;
}

IMPLEMENT_APP(TApp)