/*****************************************************************************/
/*                      WiNRADiO G35DDC EXCALIBUR ULTRA                      */
/*                                SDK DEMO                                   */
/*             Simple playback on waveform-audio output device               */
/*                        (C) Copyright RADIXON 2014                         */
/*****************************************************************************/

#ifndef __U_WAVEOUT_H__
#define __U_WAVEOUT_H__

#include <windows.h>
#include <mmsystem.h>
#include <deque>
#include "u_types.h"

#define WAVEOUT_BUFFER_COUNT    8

class TWaveOut
{
public:
    void Write(const float *Samples,uint32_t Count);
    bool Open(uint32_t SampleRate);
    void Close(void);

    TWaveOut(void);
    ~TWaveOut(void);
private:
    HWAVEOUT                m_hWaveOut;
    HANDLE                  m_hThread;
    UINT                    m_ThreadId;
    uint32_t                m_SamplesPerBuffer;
    uint32_t                m_BufferSize;
    char                    *m_Buffers[WAVEOUT_BUFFER_COUNT];
    WAVEHDR                 m_Headers[WAVEOUT_BUFFER_COUNT];
    std::deque<WAVEHDR*>    m_Avail;
    long                    m_PlayCount;
    WAVEHDR                 *m_WorkingHeader;
    uint32_t                m_WorkingPos;
    bool                    m_Float;
    CRITICAL_SECTION        m_CS;
    bool                    m_Buffering;

    static UINT __stdcall StaticThreadProcedure(void *This);
    void ThreadProcedure(void);
};


#endif //__U_WAVEOUT_H__

